Bug 826680 - Huge openjdk-javadoc package
Huge openjdk-javadoc package
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: eclipse (Show other bugs)
19
Unspecified Unspecified
unspecified Severity low
: ---
: ---
Assigned To: Alexander Kurtakov
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-05-30 14:28 EDT by Nadav Har'El
Modified: 2013-12-10 03:20 EST (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-12-10 03:20:43 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Nadav Har'El 2012-05-30 14:28:09 EDT
Description of problem:
The size of the java-1.7.0-openjdk-javadoc is totally absurd.

Version-Release number of selected component (if applicable):
java-1.7.0-openjdk-javadoc-1.7.0.3-2.1.fc17.6.noarch

How reproducible:
$ rpm -qa --qf "%{NAME} %{SIZE}\n" | grep java-1.7.0-openjdk-javadoc
java-1.7.0-openjdk-javadoc 243386595
$ du -sh /usr/share/javadoc/java-1.7.0-openjdk
307M    /usr/share/javadoc/java-1.7.0-openjdk/

Additional info:
I cannot remove the javadoc package because eclipse-jdt depends on it. But the size of the javadoc package is absurd - 1/3rd of gigabyte, easily the largest RPM in my installation. Looking at it's content, it's mainly /usr/share/javadoc/java-1.7.0-openjdk/, a huge collection of uncompressed HTML files, most of their content being endless repetition of various headers and footers. The first step would have been to simply gzip all these files - that would have at least brought this directory's size to 106M - about a third of its current size. Would doing this be possible (perhaps it would take a small patch to eclipse to read compressed files - but it sounds like a really well-deserved improvement)?

Even better would have been to remove all the HTML crap and save these files as pure minimal text files. But I don't know whether doing that would be practical as part of fedora.
Comment 1 Omair Majid 2012-05-30 14:33:51 EDT
I am not sure what eclipse needs these files for (it doesnt need them in F16). Personally I have always had eclipse use the src zip instead (you can see javadocs and step into the source using that). The src zip in fedora is about 44M. Perhaps we can somehow convince eclipse to use that instead?
Comment 2 Fedora End Of Life 2013-07-03 17:57:23 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 3 Fedora End Of Life 2013-07-31 19:30:52 EDT
Fedora 17 changed to end-of-life (EOL) status on 2013-07-30. Fedora 17 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 4 Nadav Har'El 2013-08-01 05:26:39 EDT
I don't know how to reopen this bug, but sad it was closed when NOTHING has changed, and we still have this bug on Fedora 19: The package still takes more than a quarter of a gigabyte on Fedora 19, and I still can't remove it because the eclipse-jdt package depends on.
Comment 5 Deepak Bhole 2013-08-01 09:46:58 EDT
We cannot shrink the javadoc package. Eclipse uses the package to provide documentation on hover.

Making the dependency is something Eclipse would have to do (if at all doable) -- re-assigning to Eclipse.
Comment 6 Nadav Har'El 2013-08-01 09:57:19 EDT
Eclipse guys, please reconsider not just the dependency but also if Eclipse can't get the same documentation in a much tighter format. Compression could be a good start (gzip -9 -r  /usr/share/javadoc/java-1.7.0-openjdk/ reduces it from 261M to 58M) but in the long run, I wonder if Eclipse actually needs this wasteful HTML format.
Thanks.
Comment 7 Deepak Bhole 2013-08-02 14:50:21 EDT
Eclipse folks can make the final call but FWIW, I don't think compression will work. Eclipse reads and displays the data in real-time. Any kind of compression would add a significant lag before documentation is shown to the user.
Comment 8 jiri vanek 2013-08-28 04:54:53 EDT
just my $0.002 -  When documentation in zip is loaded by eclipse, the lag is nearly zero. So maybe we can consider to deliver packed javadoc. However, the disadvantages can be visible later.

Maybe funny idea can be to have zip in package, and have it mounted as directory :)
Comment 9 Alexander Kurtakov 2013-12-10 03:20:43 EST
Dropped javadco requirement in rawhide. Using javadoc in help center would need network access for links to JVM classes. http://koji.fedoraproject.org/koji/buildinfo?buildID=482785

Note You need to log in before you can comment on or make changes to this bug.